  MEMBER

  map
    ButtonSubClassFunc(unsigned hWnd, unsigned wMsg, unsigned wParam, long lParam),long,pascal
    module('MyApiStuff')
      CallWindowProc(long, unsigned, unsigned, unsigned, long),long,pascal,name('CallWindowProcA')
      TrackMouseEvent(long),bool,pascal,name('_TrackMouseEvent')
    end
  end

  include('btnIntr.inc'),ONCE

WM_LBUTTONDOWN   equate(201H)
WM_RBUTTONDOWN   equate(204h)
WM_MOUSEHOVER    equate(2A1h)
WM_MOUSELEAVE    equate(2A3h)
WM_MOUSEMOVE     equate(200h)

TME_HOVER        equate(1h)
TME_LEAVE        equate(2h)
HOVER_DEFAULT    equate(0FFFFFFFFh)

mouseover           byte(false)
SavedProc           long
Event:ResetTrkMouse equate(656h)

WndButtonClass.ResetTracking procedure() ! byte

  code

  if TrackMouseEvent(address(Self.TrkMouse))
  end
  
  return Level:Benign
! end Resettraking ----------------------------------------------
  
WndButtonClass.SetMouseDefaults PROCEDURE(long ctrl) ! virtual 

  code 

  Self.WndCtrl = ctrl
  Self.TrkMouse.cbSize = size(self.TrkMouse)
  Self.TrkMouse.dwFlags = TME_HOVER + TME_LEAVE
  Self.TrkMouse.hwndTrack = Self.WndCtrl{prop:handle}
  Self.TrkMouse.dwHoverTime = HOVER_DEFAULT
  
  return 
! end SetMouseDefaults ----------------------------------------------------------------

WndButtonClass.RegisterHandler procedure(window w)

  code

  Self.win &= w
  SavedProc = Self.WndCtrl{Prop:WndProc}
  Self.WndCtrl{Prop:WndProc} = address(ButtonSubClassFunc)

  register(Event:MouseTrkin, address(Self.MouseHandler), address(self), self.win)
  register(Event:MouseTrkout, address(self.MouseHandler), address(self), self.win)
    
  return
! end RegisterHandler ------------------------------------------------------------

WndButtonClass.MouseHandler procedure() !byte,virtual

  code
    
  if (event() = Event:mouseTrkin)
    Self.WndCtrl{prop:icon} = '~C:\C55\images\exit3.ico'
    Self.ResetTracking()
  else
    Self.WndCtrl{prop:icon} = '~C:\C55\images\exit2.ico'
  end
  
  return level:Benign
! end IButton.MouseHandler ------------------------------------------------------------

! -------------------------------------------
! local procedure, call back for controls
! -------------------------------------------

ButtonSubClassFunc PROCEDURE(unsigned hWnd, unsigned wMsg, unsigned wParam, unsigned LParam) ! Declare Procedure

  code

  case wMsg
    of WM_MOUSEMOVE
      if (mouseOver = false)
        post(Event:MouseTrkIn,,,1)
        mouseover = true
      end   
      return 1
    of WM_MOUSELEAVE
      post(event:mouseTrkout,,,1)
      mouseover = false
      return 1
  end ! case

 ! Pass the event and it's paramters to the previous window procedure in the chain
  return CallWindowProc(SavedProc, hWnd, wMsg, wParam, LParam)
! end func -----------------------------------------------------------------------